Subject: RE: why gratuitous arp ?

From: Sumandra Majee <[email-masked]>
Date: Fri, 12 May 2000 10:47:56 -0700

VRRP keeps the same IP<->mac binding. So in essence the end host doesn't
need to know
any new binding. However I think the switches(or other L2 device) do learn
from this 
request and update their table, apart from finding any duplication of ip
address.

-----Original Message-----
On Fri, 12 May 2000, Jerome Etienne wrote:

> in the rfc2338, each time a router becomes master (rfc2338.6.2.1 
> and 6.2.2), it must "Broadcast a gratuitous ARP request containing
> the virtual router MAC address for each IP address associated with the
> virtual router". but in the text, i don't find an explaination for
> these ARP requests.
> 
> my interpretation follows, please comment:
> - It isn't for update the ARP cache of others computers because each
>   master send the exact same ARP packet. so there is no update to do.

It is.
Consider the following scenario. Two router in a network, one with 
address 1.1.1.1 and the other with 1.1.1.2. All hosts have physical MAC 
of 1.1.1.1 in their cache. Now the network Manager configures a VR
on the second router, with IP address 1.1.1.1. The router with
physical 1.1.1.1 meanwhile is struck by lightning and dies. The second
router comes up in Backup state, waits for timeout and comes up
in Master state. Don't you think the hosts deserve a grat. ARP to
update for IP 1.1.1.1 ?

What I am saying is that for cases where owner VRRP router either
dies or never comes up as Master, we need this grat. ARP from any 
router that changes state from Backup to Master.

> - Is it to detect there is multiple master at the same time ? i don't
>   think so because if it happen it is very temporary.

We have Advertisements to cover THAT. 

I hope it helps ...
Then again, what do I know, I just work here ... :-)

Hamayon

---

From: Jerome Etienne <[email-masked]>
Date: Fri, 12 May 2000 14:00:22 -0400

On Fri, May 12, 2000 at 10:47:56AM -0700, Sumandra Majee wrote:
> need to know any new binding. 

as i understood what Hamayon Mujeeb said, it is needed. i will try
to rephrase it and hope it will help. 

before the virtual router start, the ARP cache of the hosts on the network 
may contain the 'IP address owner' associated with its real MAC 
address (i.e. not the VRRP one). So when the virtual router
start and send gratuitous ARP request for the virtual router
address (which happen to be the same), so the hosts updates
their cache.
If no gratuitous ARP is sent, the hosts won't be able to communicate
until the old entry timeout.

> However I think the switches(or other L2 device) do learn
> from this